#!/bin/sh
install_dir=$1

cd $install_dir

LIBDYLIBS="libcairo-script-interpreter.2.dylib
libcairo.2.dylib
libfontconfig.1.dylib
libform.5.dylib
libfreetype.6.dylib
libgcc_s.1.dylib
libgcc_s_ppc64.1.dylib
libgcc_s_x86_64.1.dylib
libgomp.1.dylib
libgfortran.3.dylib
libhistory.6.2.dylib
libmenu.5.dylib
libncurses.5.dylib
libpanel.5.dylib
libpixman-1.0.dylib
libpng16.16.dylib
libquadmath.0.dylib
libreadline.6.2.dylib"

LIBRDYLIBS="libR.dylib
libRblas.dylib
libRlapack.dylib"

BINS="Rscript
clear
fc-cache
fc-cat
fc-list
fc-match
fc-pattern
fc-query
fc-scan
fc-validate
infocmp
png-fix-itxt
pngfix
tabs
tic
toe
tput
tset"

fix_install_name() {
    object=$1
    echo "Fixing rpath for $object \c"
    base_dy=$2
    new_libpath=$3
    base_object_path=$4
    libpaths=`./otool -L $object | grep "@executable_path" | sed -E 's#^[^/@]+([^ ]+).+#\1#g'`
    ./install_name_tool -id $new_libpath/$base_dy $object
    for origpath in $libpaths ; do
        libname=`basename $origpath`
        ./install_name_tool -change "$origpath" "$new_libpath/$libname" $object
    done
    echo "... done!"
}

for object in $LIBDYLIBS ; do
    fix_install_name lib/$object $object $install_dir/lib $install_dir/lib
done

for object in $LIBRDYLIBS ; do
    fix_install_name lib/R/lib/$object $object $install_dir/lib/R/lib $install_dir/lib/R/lib
done

for object in $BINS ; do
    fix_install_name bin/$object $object $install_dir/lib bin/
done

install_name_tool -change @executable_path/../lib/libgomp.1.dylib $install_dir/lib/libgomp.1.dylib lib/R/bin/exec/R
install_name_tool -change @executable_path/../lib/libgcc_s.1.dylib $install_dir/lib/libgcc_s.1.dylib lib/R/lib/libgomp.dylib

cd -
